# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## v4.0.2 (2021-10-09)

* update changelog

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 1 commit contributed to the release.
 - 0 commits where understood as [conventional](https://www.conventionalcommits.org).
 - 1 unique issue was worked on

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - prepare changelog for next release (716c87e)

## v4.0.1 (2021-10-07)

* fix links in documentation (#8)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 12 commits contributed to the release over the course of 613 calendar days.
 - 0 commits where understood as [conventional](https://www.conventionalcommits.org).
 - 1 unique issue was worked on

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Release treediff v4.0.1 (ebf1d8b)
    - Adjusting Changelogs prior to release of treediff v4.0.1 (02db0ae)
    - cleanup changelog (20e2e0e)
    - rename changelog to capitalized version. (12ad31b)
    - Fix broken doc comments. (8f28c92)
    - Fix serde_yaml tests - for some reason it inserts newlines to key values (6d524b4)
    - fix most of the clippy warnings (223ef3c)
    - Remove 'alpha' from next version string (27ec50b)
    - optimize imports (a52269e)
    - bye bye travis, it was a good time (c44db69)
    - Create rust.yml (7bfefb5)
    - (cargo-release) start next development iteration 4.0.1-alpha.0 (ab3a679)

## v4.0.0 (2020-02-02)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 3 commits contributed to the release.
 - 0 commits where understood as [conventional](https://www.conventionalcommits.org).
 - 1 unique issue was worked on

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - fix all lints (0ffb242)
    - Upgrade serde-yaml to the latest version (3bcb5bb)
    - (cargo-release) start next development iteration 3.0.3-alpha.0 (ffc085e)

## v3.0.2 (2020-02-02)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 2 commits contributed to the release.
 - 0 commits where understood as [conventional](https://www.conventionalcommits.org).
 - 1 unique issue was worked on

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Rust 2018 upgrades (e126c32)
    - remove clog; smaller package (176cd69)

## v3.0.1 (2018-03-12)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 1 commit contributed to the release.
 - 0 commits where understood as [conventional](https://www.conventionalcommits.org).
 - 1 unique issue was worked on

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Make filter_mut() actually return a mutable reference (cbb1b06)

## v3.0.0 (2018-03-11)

* **upgrade**: use latest versions of dependencies

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 2 commits contributed to the release over the course of 87 calendar days.
 - 0 commits where understood as [conventional](https://www.conventionalcommits.org).
 - 1 unique issue was worked on

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Update to latest versions of dependencies (0517e7c)
    - Apply latest rustfmt (ace2602)

## v2.5.3 (2017-09-24)

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 3 commits contributed to the release over the course of 30 calendar days.
 - 0 commits where understood as [conventional](https://www.conventionalcommits.org).
 - 1 unique issue was worked on

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - version bump (e0167bd)
    - Merge pull request #3 from paulrouget/serde_bump (dbac9ec)
    - serde version bump (fe8f02a)

## v2.5.1 (2017-02-22)

### other

 - <csr-id-6092375279e6fe184c8b457f0e6eb5a9f7f05d3b/> use serde 0.9.8 and Map::Entry

* **upgrade:**  use serde 0.9.8 and Map::Entry ([60923752](https://github.com/Byron/treediff-rs/commit/6092375279e6fe184c8b457f0e6eb5a9f7f05d3b))

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 2 commits contributed to the release.
 - 1 commit where understood as [conventional](https://www.conventionalcommits.org).
 - 1 unique issue was worked on

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Update changelog (323a20f)
    - use serde 0.9.8 and Map::Entry (6092375)

## v2.5.0 (2017-02-14)

### other

 - <csr-id-75fae1b2c30b9ce42012f1c9d63118e0443b9b6f/> allow keys to be cloned and displayed

* **merger:**  allow keys to be cloned and displayed ([75fae1b2](https://github.com/Byron/treediff-rs/commit/75fae1b2c30b9ce42012f1c9d63118e0443b9b6f))

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 2 commits contributed to the release.
 - 1 commit where understood as [conventional](https://www.conventionalcommits.org).
 - 1 unique issue was worked on

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - v2.5.0 (727ed22)
    - allow keys to be cloned and displayed (75fae1b)

## v2.4.0 (2017-02-14)

### other

 - <csr-id-eeb3a2da52c22d7e820fe3a40c74e55a2431ff9e/> method to obtain mutable borrow to filter
 - <csr-id-fc210ea42354be6e8febcd210bd9630040bd357d/> method to obtain immutable reference to filter.

* **merger:**
  *  method to obtain mutable borrow to filter ([eeb3a2da](https://github.com/Byron/treediff-rs/commit/eeb3a2da52c22d7e820fe3a40c74e55a2431ff9e))
  *  method to obtain immutable reference to filter. ([fc210ea4](https://github.com/Byron/treediff-rs/commit/fc210ea42354be6e8febcd210bd9630040bd357d))

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 3 commits contributed to the release.
 - 2 commits where understood as [conventional](https://www.conventionalcommits.org).
 - 1 unique issue was worked on

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - v2.4.0 (960d01c)
    - method to obtain mutable borrow to filter (eeb3a2d)
    - method to obtain immutable reference to filter. (fc210ea)

## v2.3.0 (2017-02-13)

### other

 - <csr-id-07eff4f93816bc10d4b0d5d98bcaef03741ee2c0/> handle possiblity of underflow
 - <csr-id-981c94afe98cd1da11aed290562ebe4a1e7a60cc/> add AsRef implementation

* **Merger:**  add AsRef implementation ([981c94af](https://github.com/Byron/treediff-rs/commit/981c94afe98cd1da11aed290562ebe4a1e7a60cc))
* **safety:**  handle possiblity of underflow ([07eff4f9](https://github.com/Byron/treediff-rs/commit/07eff4f93816bc10d4b0d5d98bcaef03741ee2c0))

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 3 commits contributed to the release.
 - 2 commits where understood as [conventional](https://www.conventionalcommits.org).
 - 1 unique issue was worked on

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Update changelog (49cdef0)
    - handle possiblity of underflow (07eff4f)
    - add AsRef implementation (981c94a)

## v2.2.0 (2017-02-13)

* `yaml_rust` support, for both `diff` and `merge`.

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 2 commits contributed to the release.
 - 0 commits where understood as [conventional](https://www.conventionalcommits.org).
 - 1 unique issue was worked on

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Bump to version 2.2 (3c0dc31)
    - Support for yaml-rust (88b632d)

## v2.1.1 (2017-02-13)

### other

 - <csr-id-f06102825d04bf245b5ff2ee931e8a45b94e9dd3/> fix links

* fix library documentation links

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 1 commit contributed to the release.
 - 1 commit where understood as [conventional](https://www.conventionalcommits.org).
 - 1 unique issue was worked on

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - fix links (f061028)

## v2.1.0 (2017-02-13)

* `serde_yaml` support, for both `diff` and `merge`.

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 3 commits contributed to the release.
 - 0 commits where understood as [conventional](https://www.conventionalcommits.org).
 - 1 unique issue was worked on

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Mutator/merge support for serde-yaml (5e44fe9)
    - prepare merge tests for Yaml (e132c25)
    - Add diff support for serde-yaml (8e14a85)

## v2.0.1 (2017-02-07)

### other

 - <csr-id-4dc2032561593cee1a41f2371396fade9687906c/> categories!

* **cargo:**  categories! ([4dc20325](https://github.com/Byron/treediff-rs/commit/4dc2032561593cee1a41f2371396fade9687906c))

### Commit Statistics

<csr-read-only-do-not-edit/>

 - 3 commits contributed to the release.
 - 1 commit where understood as [conventional](https://www.conventionalcommits.org).
 - 1 unique issue was worked on

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Update changelog (ed7c873)
    - categories! (4dc2032)
    - Say goodbye to git-journal, welcome back clog (67797d3)

## v2.0.0 (2017-02-07)

Improve `Merger` API considerably, and make it even more powerful.
### Commit Statistics

<csr-read-only-do-not-edit/>

 - 3 commits contributed to the release over the course of 1 calendar day.
 - 0 commits where understood as [conventional](https://www.conventionalcommits.org).
 - 1 unique issue was worked on

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Bumped version to v2.0 (a579c1c)
    - Improved merger API (e6512e2)
    - Added doc link to Readme (d84c44f)

## v1.0.0 (2017-02-05)

Initial release.
### Commit Statistics

<csr-read-only-do-not-edit/>

 - 74 commits contributed to the release over the course of 23 calendar days.
 - 0 commits where understood as [conventional](https://www.conventionalcommits.org).
 - 1 unique issue was worked on

### Commit Details

<csr-read-only-do-not-edit/>

view details

 * **Uncategorized**
    - Changed version to v1.0.0 (958a1f3)
    - Added all remaining docs (f17d671)
    - Improved crate structure (5d0c76e)
    - Added even more docs/structural changes (b463311)
    - Improved module layout (367aaf4)
    - Added docs for main traits (2d6a8a8)
    - Removed unnecessary options in API (a370969)
    - Added some more docs (ea88d65)
    - Added support for value removal on conflict (1195299)
    - Added some crate docs (17fd836)
    - Improved project structure (5abc89d)
    - Improved suite definitions (96d3b98)
    - Added Merge support for serde-json (f932d4a)
    - Improved API to support arbitrary modifications when merging (038256d)
    - Improved API by using Cow only when needed (773cd1b)
    - Added support for deletion handler (a298c50)
    - Added test to verify conflict resolver. (46f766a)
    - Improved delegate clarity and capability of resolve() (d4eae6a)
    - Improved delegate interface consistency (1bcd40a)
    - Added groundwork for resolving conflicts (5630e87)
    - Added generalized suite for merge tests (d146dba)
    - Improved json value tests (fa1bf24)
    - Added diff support for serde_json Value (cf1934a)
    - Added json value suite (1070cd4)
    - Changed structure in preparation for serde (ef34105)
    - Added remove_key support for json (0b12455)
    - Changed license to MIT/Apache2 (b734959)
    - Added handling for merging arrays (3749007)
    - Improved object setter code (c141b92)
    - Improved mergeable trait to not degenerate information (d448e7c)
    - Added key removal and modification for merge (d19b005)
    - Added added-key tests and impl (52cb2b6)
    - Added a few tests to assert Mergeable.set() (e1d2c14)
    - Added merge infrastructure (4347535)
    - Improved key ownership (627ba19)
    - Added full key support (843d18b)
    - Added preliminary key support (70101cc)
    - Added handling for scalar/object comparisons (434b533)
    - Added implementation for nested object handling (86fbe0a)
    - Added key addition and removal (41abd1e)
    - Fixed tests (e7905a8)
    - Improved type definition (1694109)
    - Revert "Added futile attempt to workaround type issue" (420e19c)
    - Added futile attempt to workaround type issue (01a4b58)
    - Added attempt to use a recursive type (a7eec83)
    - Removed std entirely (94b8479)
    - Changed diff to get closer to finding differences (6528fa5)
    - Improved travis to not run unnecessary tests (048038d)
    - Added Value for HashMap (60ef3cf)
    - Added json array value (b0304d1)
    - Added tests for all json scalars and the json object (0560d81)
    - Added first scalar Json value (10b9858)
    - Added JsonKey to abstract over usize/String (5ac03ce)
    - Added first version of json Value impl (837f56f)
    - Added modification of scalar values. (6dee766)
    - Added utils module (42e7c3c)
    - Improved Delegate to support references (3e31491)
    - Improved ChangeType to contain values (9c5904f)
    - Added first stub of diff function (01d388b)
    - Removed with-std feature (d14deb4)
    - Fixed trait type signature to use iterator (ca6ea4e)
    - Improved trait signature (569c930)
    - Changed trait to just copy everything (9f8203e)
    - Revert "Changed trait to support hacky polymorphism" (eb019cc)
    - Changed trait to support hacky polymorphism (e544f55)
    - Improved definition of trait implementation (4bb8b7d)
    - Improved trait lifetime handling (8107a4c)
    - Added simplified non-working items() method (e618706)
    - Improved trait by simplifying it (c274604)
    - Added attempt to create an iterator based items() method (edb547e)
    - Improved Value trait (26ff8d4)
    - Added first impl of Value Trait for String (1822a45)
    - Added git-journal support (15e670a)
    - Initial commit (83f2154)

